import tape from "tape"
import DynamoDOWN from "./level-dynamo"
import aws from "aws-sdk"

import * as testCommon from "./test-common"
import leveldownTest from "abstract-leveldown/abstract/leveldown-test"
import openTest from "abstract-leveldown/abstract/open-test"
import delTest from "abstract-leveldown/abstract/del-test"
import putTest from "abstract-leveldown/abstract/put-test"
import getTest from "abstract-leveldown/abstract/get-test"
import putGetDelTest from "abstract-leveldown/abstract/put-get-del-test"
import closeTest from "abstract-leveldown/abstract/close-test"
import iteratorTest from "abstract-leveldown/abstract/iterator-test"
import chainedBatchTest from "abstract-leveldown/abstract/chained-batch-test"
import approximateSizeTest from "abstract-leveldown/abstract/approximate-size-test"
import rangesTest from "abstract-leveldown/abstract/ranges-test"
import batchTest from "abstract-leveldown/abstract/batch-test"

const dynamo = new aws.DynamoDB({region: "us-east-1"})
const dynamoDOWN = DynamoDOWN(dynamo)
const testBuffer = Buffer("hello")

leveldownTest.args(dynamoDOWN, tape)
openTest.args(dynamoDOWN, tape, testCommon)
delTest.all(dynamoDOWN, tape, testCommon)
putTest.all(dynamoDOWN, tape, testCommon)
getTest.all(dynamoDOWN, tape, testCommon)
putGetDelTest.all(dynamoDOWN, tape, testCommon, testBuffer)
// require("abstract-leveldown/abstract/close-test").close(dynamoDOWN, tape, testCommon);
// require("abstract-leveldown/abstract/iterator-test").all(dynamoDOWN, tape, testCommon);

// require("abstract-leveldown/abstract/chained-batch-test").all(dynamoDOWN, tape, testCommon);
// require("abstract-leveldown/abstract/approximate-size-test").setUp(dynamoDOWN, tape, testCommon);
// require("abstract-leveldown/abstract/approximate-size-test").args(dynamoDOWN, tape, testCommon);

// require("abstract-leveldown/abstract/ranges-test").all(dynamoDOWN, tape, testCommon);
// require("abstract-leveldown/abstract/batch-test").all(dynamoDOWN, tape, testCommon);



// import DynamoDOWN from "./level-dynamo"
// import aws from "aws-sdk"
// import levelup from "levelup"
// import stream from "stream"

// const dynamo = new aws.DynamoDB({region: "us-east-1"})
// const dynamoDOWN = DynamoDOWN(dynamo)

// const db = levelup("level-test/foo", {db: dynamoDOWN})

// db.createReadStream()
//   .on("data", console.log)
//   // .pipe(new stream.Transform({
//   //   objectMode: true,
//   //   transform: (data, enc, cb) => {
//   //     data.type = "del"
//   //     delete data.value
//   //     cb(null, data)
//   //   }
//   // }))
//   // .pipe(db.createWriteStream())

// // db.createWriteStream()

// // const ws = db.createWriteStream()

// // for (var i = 0; i < 500; i++) {
// //   ws.write({key: String(i), value: Math.random()})
// // }

// // ws.end()


// // db.put("bar", Math.random(), (err) => {
// //   db.put("baz", Math.random(), (err) => {
// //     db.createReadStream({gt: "bar"}).on("data", console.log)
// //   })
// // })

